-------------------------------------------------------------------------------------------------
-- This file shows the new server methods and the changes to Check_Delete___ and Check_Common___. 
-------------------------------------------------------------------------------------------------

PROCEDURE Copy_To_Companies (
   source_company_       IN VARCHAR2,
   target_company_list_  IN VARCHAR2,
   attribute_list_       IN VARCHAR2,
   attribute_value_list_ IN VARCHAR2,
   update_method_list_   IN VARCHAR2,
   copy_type_            IN VARCHAR2,
   attr_                 IN VARCHAR2 DEFAULT NULL)
IS
   attr1_                  VARCHAR2(32000);
BEGIN
   Client_SYS.Add_To_Attr('SOURCE_COMPANY', source_company_, attr1_);
   Client_SYS.Add_To_Attr('TARGET_COMPANY_LIST', target_company_list_, attr1_);
   Client_SYS.Add_To_Attr('ATTRIBUTE_LIST', attribute_list_, attr1_);
   Client_SYS.Add_To_Attr('ATTRIBUTE_VALUE_LIST', attribute_value_list_, attr1_);
   Client_SYS.Add_To_Attr('UPDATE_METHOD_LIST', update_method_list_, attr1_);
   Client_SYS.Add_To_Attr('COPY_TYPE', copy_type_, attr1_);
   Client_SYS.Add_To_Attr('ATTR', attr_, attr1_);
   Transaction_SYS.Deferred_Call('Accounting_Attribute_Value_API.Copy_To_Companies_', attr1_, Language_SYS.Translate_Constant(lu_name_, 'COPYDATA: Copy Basic Data')); 
END Copy_To_Companies;


PROCEDURE Copy_To_Companies_ (
   attr_ IN  VARCHAR2 )
IS
   ptr_                  NUMBER;
   name_                 VARCHAR2(200);
   value_                VARCHAR2(32000);
   source_company_       VARCHAR2(100);
   target_company_list_  VARCHAR2(2000);
   attribute_list_       VARCHAR2(2000);
   attribute_value_list_ VARCHAR2(2000);
   update_method_list_   VARCHAR2(2000);
   copy_type_            VARCHAR2(100);
   attr1_                VARCHAR2(32000);
BEGIN
   ptr_ := NULL;
   WHILE (Client_SYS.Get_Next_From_Attr(attr_, ptr_, name_, value_)) LOOP
      IF (name_ = 'SOURCE_COMPANY') THEN
         source_company_ := value_;
      ELSIF (name_ = 'TARGET_COMPANY_LIST') THEN
         target_company_list_ := value_;
      ELSIF (name_ = 'ATTRIBUTE_LIST') THEN
         attribute_list_ := value_;
      ELSIF (name_ = 'ATTRIBUTE_VALUE_LIST') THEN
         attribute_value_list_ := value_;         
      ELSIF (name_ = 'UPDATE_METHOD_LIST') THEN
         update_method_list_ := value_;
      ELSIF (name_ = 'COPY_TYPE') THEN
         copy_type_ := value_;
      ELSIF (name_ = 'ATTR') THEN
         attr1_ := value_||chr(30)||substr(attr_, ptr_,length(attr_)-1);
      END IF;
   END LOOP;
   Copy_To_Companies_(source_company_,
                      target_company_list_,
                      attribute_list_,
                      attribute_value_list_,
                      update_method_list_,
                      copy_type_,
                      attr1_);
END Copy_To_Companies_;


PROCEDURE Copy_To_Companies_ (
   source_company_       IN  VARCHAR2,
   target_company_list_  IN  VARCHAR2,
   attribute_list_       IN  VARCHAR2,
   attribute_value_list_ IN VARCHAR2,
   update_method_list_   IN  VARCHAR2,
   copy_type_            IN  VARCHAR2,
   attr_                 IN  VARCHAR2 DEFAULT NULL)
IS
   ptr_                          NUMBER;
   ptr1_                         NUMBER;
   ptr2_                         NUMBER;
   i_                            NUMBER;
   update_method_                VARCHAR2(20);
   value_                        VARCHAR2(2000);
   target_company_               accounting_attribute_value_tab.company%TYPE;
   TYPE accounting_attribute_value IS TABLE OF accounting_attribute_value_tab%ROWTYPE 
                                 INDEX BY BINARY_INTEGER;
   TYPE attr IS TABLE OF VARCHAR2 (32000) 
                                 INDEX BY BINARY_INTEGER;
   ref_accounting_attribute_val_ accounting_attribute_value;
   ref_attr_                     attr;
   log_id_                       NUMBER;
   attr_value_                   VARCHAR2(32000) := NULL;   
BEGIN
   ptr1_ := NULL;
   ptr2_ := NULL;
   
   i_    := 0;
   ptr_  := NULL;
   WHILE Get_Next_Record_Sep_Val___(value_, ptr_, attribute_list_) LOOP
      ref_accounting_attribute_val_(i_).attribute := value_;
      i_ := i_ + 1;
   END LOOP;
   
   i_    := 0;
   ptr_  := NULL;
   WHILE Get_Next_Record_Sep_Val___(value_, ptr_, attribute_value_list_) LOOP
      ref_accounting_attribute_val_(i_).attribute_value := value_;
      i_ := i_ + 1;
   END LOOP;   
   
   i_    := 0;
   ptr_  := NULL;
   WHILE Get_Next_Record_Sep_Val___(value_, ptr_, attr_) LOOP
      ref_attr_(i_) := value_;
      i_ := i_ + 1;
   END LOOP;
   
   IF (target_company_list_ IS NOT NULL) THEN
     Copy_Basic_Data_Log_API.Create_New_Record(log_id_, source_company_, copy_type_,lu_name_);
   END IF;
   WHILE Get_Next_Record_Sep_Val___(target_company_, ptr1_, target_company_list_) LOOP      
      IF (Get_Next_Record_Sep_Val___(update_method_, ptr2_, update_method_list_)) THEN
         FOR j_ IN ref_accounting_attribute_val_.FIRST..ref_accounting_attribute_val_.LAST LOOP
            IF (ref_attr_.FIRST IS NOT NULL) THEN
               attr_value_ := ref_attr_(j_);
            END IF;            
            Copy_To_Companies__ (source_company_,  
                                 target_company_,
                                 ref_accounting_attribute_val_(j_).attribute,
                                 ref_accounting_attribute_val_(j_).attribute_value,
                                 update_method_,
                                 log_id_,
                                 attr_value_);
         END LOOP;
      END IF;
   END LOOP;
   IF (target_company_list_ IS NOT NULL) THEN
      Copy_Basic_Data_Log_API.Update_Status(log_id_);
   END IF;
END Copy_To_Companies_;


PROCEDURE Copy_To_Companies__ (
   source_company_  IN VARCHAR2,
   target_company_  IN VARCHAR2,
   attribute_       IN VARCHAR2,
   attribute_value_ IN VARCHAR2,
   update_method_   IN VARCHAR2,
   log_id_          IN NUMBER,
   attr_            IN VARCHAR2 DEFAULT NULL)
IS
   source_rec_              accounting_attribute_value_tab%ROWTYPE;
   target_rec_              accounting_attribute_value_tab%ROWTYPE;
   old_target_rec_          accounting_attribute_value_tab%ROWTYPE;
   log_key_                 VARCHAR2(2000);
   log_detail_status_       VARCHAR2(10);
   attr2_                   VARCHAR2(32000) := attr_;
   old_target_info_         VARCHAR2(2000);
   old_target_objid_        VARCHAR2(20);
   old_target_objversion_   VARCHAR2(100);   
BEGIN
   source_rec_ := Get_Object_By_Keys___(source_company_, attribute_, attribute_value_);
   target_rec_ := source_rec_;
   target_rec_.company := target_company_;
   App_Context_Sys.Set_Value(lu_name_||'.copy_to_company_', 'TRUE');
   old_target_rec_ := Get_Object_By_Keys___(target_company_, attribute_, attribute_value_);
   log_key_ := attribute_ || '^' || attribute_value_;
   IF (source_rec_.rowkey IS NOT NULL AND old_target_rec_.rowkey IS NULL) THEN
      -- Source creates a new record which does not exist in the target company
      New___(target_rec_);
      log_detail_status_ := 'CREATED';
   ELSIF (source_rec_.rowkey IS NOT NULL AND old_target_rec_.rowkey IS NOT NULL AND update_method_ = 'UPDATE_ALL') THEN
      -- Source company adds or modifies a record, the same exists in the target company and the user wants to update the entire record in the target
      target_rec_.rowkey := old_target_rec_.rowkey;
      Modify___(target_rec_);
      log_detail_status_ := 'MODIFIED';
   ELSIF (source_rec_.rowkey IS NOT NULL AND old_target_rec_.rowkey IS NOT NULL AND update_method_ = 'MODIFICATION_ONLY') THEN
      -- Source company adds or modifies a record, the same exists in the target company and the user wants to update the modification only in the target
      Get_Id_Version_By_Keys___(old_target_objid_, old_target_objversion_, target_company_, attribute_, attribute_value_);
      Modify__(old_target_info_, old_target_objid_, old_target_objversion_, attr2_, 'DO');
      log_detail_status_ := 'MODIFIED';      
   ELSIF (source_rec_.rowkey IS NULL AND old_target_rec_.rowkey IS NOT NULL) THEN
      -- Source removes a record, the same record is removed in the target company
      Remove___(old_target_rec_);      
      log_detail_status_ := 'REMOVED';      
   ELSIF (source_rec_.rowkey IS NULL AND old_target_rec_.rowkey IS NULL) THEN
      -- Source removes a record, the same record does not exist in the target company to be removed
      Raise_Record_Not_Exist___(target_company_, attribute_, attribute_value_);
   ELSIF (source_rec_.rowkey IS NOT NULL AND old_target_rec_.rowkey IS NOT NULL AND update_method_ = 'NO_UPDATE') THEN
      -- Source company adds or modifies a record, the same exists in the target company and the user does not wan to update records in the target
      Raise_Record_Exist___(target_rec_);
   END IF; 
   IF (Company_Basic_Data_Window_API.Check_Copy_From_Source_Company(target_company_,source_company_, lu_name_)) THEN
      IF log_detail_status_ IN ('CREATED','MODIFIED') THEN
         Error_SYS.Record_General(lu_name_, 'NODIRECTINSERT: A record cannot be entered/modified as :P1 window has been set up for copying data only from source company in Basic Data Synchronization window.', Basic_Data_Window_API.Get_Window(lu_name_));
      ELSIF log_detail_status_ = 'REMOVED' THEN
         Error_SYS.Record_General(lu_name_, 'NODIRECTREMOVE: A record cannot be removed as :P1 window has been set up for copying data only from source company in Basic Data Synchronization window.', Basic_Data_Window_API.Get_Window(lu_name_));
      END IF;
   END IF;
   App_Context_Sys.Set_Value(lu_name_||'.copy_to_company_', 'FALSE');
   Copy_Basic_Data_Log_Detail_API.Create_New_Record(log_id_, target_company_, log_key_, log_detail_status_);
EXCEPTION
   WHEN OTHERS THEN
      log_detail_status_ := 'ERROR';
      Copy_Basic_Data_Log_Detail_API.Create_New_Record(log_id_, target_company_, log_key_, log_detail_status_, SQLERRM);
END Copy_To_Companies__;


FUNCTION Get_Next_Record_Sep_Val___ (
   value_ IN OUT VARCHAR2,
   ptr_   IN OUT NUMBER,  
   attr_  IN     VARCHAR2 ) RETURN BOOLEAN
IS
   from_              NUMBER;
   to_                NUMBER;
   field_separator_   VARCHAR2(1)  := chr(28);
BEGIN
   from_ := nvl(ptr_, 1);
   to_   := instr(attr_, field_separator_, from_);
   IF (to_ > 0) THEN
      value_ := substr(attr_, from_, to_-from_);
      ptr_   := to_+1;
      RETURN TRUE;
   ELSE
      RETURN FALSE;
   END IF;
END Get_Next_Record_Sep_Val___;


PROCEDURE Check_Delete___ (
   remrec_ IN accounting_attribute_value_tab%ROWTYPE )
IS
BEGIN
   IF (App_Context_Sys.Find_Value(lu_name_||'.copy_to_company_', 'FALSE') != 'TRUE') THEN
      IF (Company_Basic_Data_Window_API.Check_Copy_From_Company(remrec_.company, lu_name_)) THEN
         Error_SYS.Record_General(lu_name_, 'NODIRECTREMOVE: A record cannot be removed as :P1 window has been set up for copying data only from source company in Basic Data Synchronization window.', Basic_Data_Window_API.Get_Window(lu_name_));
      END IF;
   END IF;
   super(remrec_);
END Check_Delete___;


PROCEDURE Check_Common___ (
   oldrec_ IN     accounting_attribute_value_tab%ROWTYPE,
   newrec_ IN OUT accounting_attribute_value_tab%ROWTYPE,
   indrec_ IN OUT Indicator_Rec,
   attr_   IN OUT VARCHAR2 )
IS
BEGIN
   IF (App_Context_Sys.Find_Value(lu_name_||'.copy_to_company_', 'FALSE') != 'TRUE') THEN
      IF (Company_Basic_Data_Window_API.Check_Copy_From_Company(newrec_.company, lu_name_)) THEN
         Error_SYS.Record_General(lu_name_, 'NODIRECTINSERT: A record cannot be entered/modified as :P1 window has been set up for copying data only from source company in Basic Data Synchronization window.', Basic_Data_Window_API.Get_Window(lu_name_));
      END IF;
   END IF;   
   super(oldrec_, newrec_, indrec_, attr_);
END Check_Common___;

