using Ifs.Application.Enterp.Classes;

namespace Ifs.Application.Accrul_
{
    [FndWindowRegistration("PAYMENT_TERM_DETAILS", "PaymentTermDetails")]
    public partial class frmPaymentTermDetails : cFormWindowFin
    {
        #region Window Variables
        protected SalBoolean bMasterIsDirty = false;
        protected SalBoolean bChildIsDirty  = false;
        protected SalString sLu1 = "PaymentTerm";
        protected SalString sLu2 = "PaymentTermDetails";
        protected SalString sState1 = "";
        protected SalString sState2 = "";
        protected SalString sAllInfo1 = "";
        protected SalString sAllInfo2 = "";
        protected SalString sType1 = "";
        protected SalString sType2 = "";
        protected SalNumber nLogId1 = 0;
        protected SalNumber nLogId2 = 0;
        protected SalString sWindow1 = "";
        protected SalString sWindow2 = "";
        protected SalArray<SalString> lsAttr1 = new SalArray<SalString>();
        protected SalArray<SalString> lsAttr2 = new SalArray<SalString>();
        protected SalArray<SalString> sParams1 = new SalArray<SalString>();
        protected SalArray<SalString> sParams2 = new SalArray<SalString>();
        protected SalArray<SalString> sItemNames = new SalArray<SalString>();
        protected SalArray<SalWindowHandle> cControls1 = new SalArray<SalWindowHandle>();
        protected SalArray<SalWindowHandle> cControls2 = new SalArray<SalWindowHandle>();
        #endregion
		
        #region Window Actions
		private void frmPaymentTermDetails_WindowActions(object sender, WindowActionsEventArgs e)
        {
            #region Actions
            switch (e.ActionType)
            {
                case Ifs.Fnd.ApplicationForms.Const.PM_DataSourceSave:
                    this.frmPaymentTermDetails_OnPM_DataSourceSave(sender, e);
                    break;
            }
            #endregion
        }

        private void frmPaymentTermDetails_OnPM_DataSourceSave(object sender, WindowActionsEventArgs e)
        {
            #region Actions
            e.Handled = true;
            if (Sys.wParam == Ifs.Fnd.ApplicationForms.Const.METHOD_Execute)
            {
                this.bRetValue = Sal.SendClassMessage(Ifs.Fnd.ApplicationForms.Const.PM_DataSourceSave, Sys.wParam, Sys.lParam);
                if (this.bRetValue)
                {
                    Sal.SendMsg(this.tblPaymentTermDetails, Ifs.Fnd.ApplicationForms.Const.PM_DataSourcePopulate, Ifs.Fnd.ApplicationForms.Const.METHOD_Execute, Ifs.Fnd.ApplicationForms.Const.POPULATE_Single);
                    if (Sys.wParam == Ifs.Fnd.ApplicationForms.Const.METHOD_Execute)
                    {
                        if (!bChildIsDirty)
                        {
                            if (cCopyToCompany.NavigateToCopyBasicDataLog(ref sAllInfo1, sParams1))
                            {
                                bMasterIsDirty = false;
                                bChildIsDirty = false;
                                NavigateToCopyBasicDataLog();
                            }
                        }
                        if (cCopyToCompany.NavigateToCopyBasicDataLog(ref sAllInfo2, sParams2))
                        {
                            bMasterIsDirty = false;
                            bChildIsDirty = false;
                            NavigateToCopyBasicDataLog();
                        }
                        
                    }
                }
                else
                {
                    lsAttr1.Clear();
                    lsAttr2.Clear();
                }
                e.Return = this.bRetValue;
                return;
            }
            e.Return = Sal.SendClassMessage(Ifs.Fnd.ApplicationForms.Const.PM_DataSourceSave, Sys.wParam, Sys.lParam);
            return;
            #endregion
        }
        #endregion

        #region Late Bind Methods

        public override SalNumber vrtDataRecordFetchEditedUser(ref SalString lsAttr)
        {
            return this.DataRecordFetchEditedUser(ref lsAttr);
        }

        public override SalBoolean vrtDataSourceSaveCheckOk()
        {
            return DataSourceSaveCheckOk();
        }

        public new SalNumber DataRecordFetchEditedUser(ref SalString lsServerAttr)
        {
            #region Actions
            bMasterIsDirty = true;
            lsAttr1[lsAttr1.Length] = lsServerAttr;
            return 0;
            #endregion
        }

        public new SalBoolean DataSourceSaveCheckOk()
        {
            #region Actions
            DbPLSQLBlock(@" {0} := &AO.Company_Basic_Data_Window_API.Is_Active_Lu_Exist( {1} IN,{2} IN) ;
                            {3} := &AO.Company_Basic_Data_Window_API.Is_Active_Lu_Exist( {1} IN,{4} IN) ;",
                                                  this.QualifiedVarBindName("sState1"),
                                                  this.QualifiedVarBindName("i_sCompany"),
                                                  this.QualifiedVarBindName("sLu1"),
                                                  this.QualifiedVarBindName("sState2"),
                                                   this.QualifiedVarBindName("sLu2"));
            cControls1[0] = this.cmbPayTermId;

            cControls2[0] = tblPaymentTermDetails_colsPayTermId;
            cControls2[1] = tblPaymentTermDetails_colnInstallmentNumber;
            cControls2[2] = tblPaymentTermDetails_colnDayFrom;
            if ((bMasterIsDirty && (!bChildIsDirty) && (sState1 == "TRUE")) || (bMasterIsDirty && bChildIsDirty && (sState1 == "TRUE") && (sState2 != "TRUE")))
            {
                if (sState1 == "TRUE")
                {
                    sType1 = "AUTOMATIC";
                    cCopyToCompany.CopyToCompanies(Ifs.Fnd.ApplicationForms.Const.METHOD_Execute, this, sLu1, "Payment_Term_API", cControls1, i_sCompany, sType1, ref this.lsAttr1, ref sAllInfo1, ref sWindow1, ref nLogId1);
                    sParams1[0] = sWindow1;
                    sItemNames[0] = nLogId1.ToString();
                }
            }
            else if (((!bMasterIsDirty) && bChildIsDirty && (sState2 == "TRUE")) || (bMasterIsDirty && bChildIsDirty && (sState2 == "TRUE") && (sState1 != "TRUE")))
            {
                sType2 = "AUTOMATIC";
                cCopyToCompany.CopyToCompanies(Ifs.Fnd.ApplicationForms.Const.METHOD_Execute, this.tblPaymentTermDetails, sLu2, "Payment_Term_Details_API", cControls2, i_sCompany, sType2, ref this.lsAttr2, ref sAllInfo2, ref sWindow2, ref nLogId2);
                sParams2[0] = sWindow2;
                sItemNames[0] = nLogId2.ToString();
            }
            else if (bMasterIsDirty && bChildIsDirty && (sState2 == "TRUE") && (sState1 == "TRUE"))
            {
                sType1 = "AUTOMATIC";
                cCopyToCompany.CopyToCompanies(Ifs.Fnd.ApplicationForms.Const.METHOD_Execute, this, sLu1, "Payment_Term_API", cControls1, i_sCompany, sType1, ref this.lsAttr1, ref sAllInfo1, ref sWindow1, ref nLogId1, this.tblPaymentTermDetails, sLu1, "Payment_Term_Details_API",cControls2, ref this.lsAttr2, ref sAllInfo2, ref sWindow2, ref nLogId2);
                sParams1[0] = sWindow1;
                sParams2[0] = sWindow2;
                sItemNames[0] = nLogId2.ToString();
            }
            
            return true;
            #endregion
        }

        public virtual void NavigateToCopyBasicDataLog()
        {

            #region Actions
            Ifs.Fnd.ApplicationForms.Var.DataTransfer.Reset();
            Ifs.Fnd.ApplicationForms.Var.DataTransfer.SourceNameSet("LOG_DETAIL");
            Ifs.Fnd.ApplicationForms.Var.DataTransfer.ItemAdd("LOG_ID", sItemNames);
            SessionNavigate(Pal.GetActiveInstanceName("tbwCopyBasicDataLog"));
            #endregion
        }
        #endregion

        #region ChildTable-tblPaymentTermDetails

		private void tblPaymentTermDetails_DataRecordFetchEditedUserEvent(object sender, cDataSource.DataRecordFetchEditedUserEventArgs e)
        {
            #region Actions
            bChildIsDirty = true;
            e.Handled = true;
            lsAttr2[lsAttr2.Length] = e.lsAttr;
            #endregion
        }
        private void menuTbwMethods_menuCopy_To_Companies1____Execute(object sender, FndCommandExecuteEventArgs e)
        {
            sType2 = "MANUAL";
            cControls2[0] = tblPaymentTermDetails_colsPayTermId;
            cControls2[1] = tblPaymentTermDetails_colnInstallmentNumber;
            cControls2[2] = tblPaymentTermDetails_colnDayFrom;
            cCopyToCompany.CopyToCompanies(Ifs.Fnd.ApplicationForms.Const.METHOD_Execute, this.tblPaymentTermDetails, sLu2, "Payment_Term_Details_API", cControls2, i_sCompany, sType2, ref this.lsAttr2, ref sAllInfo2, ref sWindow2, ref nLogId2);
            sParams2[0] = sWindow2;
            if (cCopyToCompany.NavigateToCopyBasicDataLog(ref sAllInfo2, sParams2))
            {
                sItemNames[0] = nLogId2.ToString();
                NavigateToCopyBasicDataLog();
            }
        }

        private void menuTbwMethods_menuCopy_To_Companies1____Inquire(object sender, FndCommandInquireEventArgs e)
        {
            ((FndCommand)sender).Enabled = cCopyToCompany.CopyToCompanies(Ifs.Fnd.ApplicationForms.Const.METHOD_Inquire, this.tblPaymentTermDetails, sLu2, "Payment_Term_Details_API", cControls2, i_sCompany, sType2, ref this.lsAttr2, ref sAllInfo2, ref sWindow2, ref nLogId2);
        }

        private void menuFrmMethods_menuCopy_To_Companies____Execute(object sender, FndCommandExecuteEventArgs e)
        {
            sType1 = "MANUAL";
            cControls1[0] = this.cmbPayTermId;
            cCopyToCompany.CopyToCompanies(Ifs.Fnd.ApplicationForms.Const.METHOD_Execute, this, sLu1, "Payment_Term_API", cControls1, i_sCompany, sType1, ref this.lsAttr1, ref sAllInfo1, ref sWindow1, ref nLogId1);
            sParams1[0] = sWindow1;
            if (cCopyToCompany.NavigateToCopyBasicDataLog(ref sAllInfo1, sParams1))
            {
                sItemNames[0] = nLogId1.ToString();
                NavigateToCopyBasicDataLog();
            }
        }

        private void menuFrmMethods_menuCopy_To_Companies____Inquire(object sender, FndCommandInquireEventArgs e)
        {
            ((FndCommand)sender).Enabled = cCopyToCompany.CopyToCompanies(Ifs.Fnd.ApplicationForms.Const.METHOD_Inquire, this, sLu1, "Payment_Term_API", cControls1, i_sCompany, sType1, ref this.lsAttr1, ref sAllInfo1, ref sWindow1, ref nLogId1);
        }

        #endregion
    }
}
