using Ifs.Application.Enterp.Classes;

namespace Ifs.Application.Accrul
{
    [FndWindowRegistration("ACCOUNTING_ATTRIBUTE", "AccountingAttribute", FndWindowRegistrationFlags.HomePage)]
    public partial class tbwAttribute : cTableWindowFin
    {
        #region Window Variables
        protected SalString sLu = "AccountingAttribute";
        protected SalString sState = "";
        protected SalString sAllInfo = "";
        protected SalString sType = "";
        protected SalNumber nLogId = 0;
        protected SalString sWindow = "";
        protected SalArray<SalString> lsAttr = new SalArray<SalString>();
        protected SalArray<SalString> sParams = new SalArray<SalString>();
        protected SalArray<SalWindowHandle> cControls = new SalArray<SalWindowHandle>();

        #endregion

        #region Methods

        public new SalBoolean DataSourceSaveCheckOk()
        {
            #region Actions
            DbPLSQLBlock(@" {0} := &AO.Company_Basic_Data_Window_API.Is_Active_Lu_Exist( {1} IN,{2} IN) ;",
                                                  this.QualifiedVarBindName("sState"),
                                                  this.QualifiedVarBindName("i_sCompany"),
                                                  this.QualifiedVarBindName("sLu"));
            if (sState == "TRUE")
            {
                sType = "AUTOMATIC";
                cControls[0] = colsAttribute;
                cCopyToCompany.CopyToCompanies(Ifs.Fnd.ApplicationForms.Const.METHOD_Execute, this, sLu, "Accounting_Attribute_API", cControls, i_sCompany, sType, ref this.lsAttr, ref sAllInfo, ref sWindow, ref nLogId);
                sParams[0] = sWindow;
            }
            return true;
            #endregion
        }

        public new SalNumber DataRecordFetchEditedUser(ref SalString lsServerAttr)
        {
            #region Actions
            lsAttr[lsAttr.Length] = lsServerAttr;
            return 0;
            #endregion
        }

        #endregion

        #region Window Actions
        private void tbwAttribute_WindowActions(object sender, WindowActionsEventArgs e)
        {
            #region Actions
            switch (e.ActionType)
            {

                case Ifs.Fnd.ApplicationForms.Const.PM_DataSourceSave:
                    this.tbwAttribute_OnPM_DataSourceSave(sender, e);
                    break;
            }
            #endregion
        }

        private void tbwAttribute_OnPM_DataSourceSave(object sender, WindowActionsEventArgs e)
        {
            #region Actions
            e.Handled = true;
            if (Sal.SendClassMessage(Ifs.Fnd.ApplicationForms.Const.PM_DataSourceSave, Sys.wParam, Sys.lParam))
            {
                e.Return = true;
                if (Sys.wParam == Ifs.Fnd.ApplicationForms.Const.METHOD_Execute)
                {
                    if (cCopyToCompany.NavigateToCopyBasicDataLog(ref sAllInfo, sParams))
                    {
                        NavigateToCopyBasicDataLog();
                    }
                }
                return;
            }
            else
            {
                lsAttr.Clear();
                e.Return = false;
                return;
            }
            
            #endregion
        }
        #endregion

        #region Late Bind Methods
        public override SalBoolean vrtDataSourceSaveCheckOk()
        {
            return DataSourceSaveCheckOk();
        }
        #endregion

        #region Event Handlers
		private void menuTbwMethods_menuCopy_To_Companies____Execute(object sender, FndCommandExecuteEventArgs e)
        {
            sType = "MANUAL";
            cControls[0] = colsAttribute;
            cCopyToCompany.CopyToCompanies(Ifs.Fnd.ApplicationForms.Const.METHOD_Execute, this, sLu, "Accounting_Attribute_API", cControls, i_sCompany, sType, ref this.lsAttr, ref sAllInfo, ref sWindow, ref nLogId);
            sParams[0] = sWindow;
            if (cCopyToCompany.NavigateToCopyBasicDataLog(ref sAllInfo, sParams))
            {
                NavigateToCopyBasicDataLog();
            }
        }

        private void menuTbwMethods_menuCopy_To_Companies____Inquire(object sender, FndCommandInquireEventArgs e)
        {
            ((FndCommand)sender).Enabled = cCopyToCompany.CopyToCompanies(Ifs.Fnd.ApplicationForms.Const.METHOD_Inquire, this, sLu, "Accounting_Attribute_API", cControls, i_sCompany, sType, ref this.lsAttr, ref sAllInfo, ref sWindow, ref nLogId);
        }
        #endregion

        

    }
}
